package cn.yw.operationcount.latandloncount.action;


import java.io.File;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import cn.base.aspect.OperateType;
import cn.base.bean.BaseAction;
import cn.base.excel.ExcelCol;
import cn.base.excel.ExportEngine;
import cn.base.excel.ExportExcel;
import cn.base.pdf.ExportPDF;
import cn.base.util.CommUtils;
import cn.base.util.Constants;
import cn.base.util.DateUtil;
import cn.base.util.LogConstants;
import cn.base.util.StringUtil;
import cn.base.util.Struts2Utils;
import cn.bsystem.ptuserrole.model.PtyhBean;
import cn.yw.operationcount.latandloncount.service.YwcountlalcollectService;
import net.sf.json.JSONObject;

@SuppressWarnings({"all"})
@Component("ywcountlalcollectAction")
public class YwcountlalcollectAction extends BaseAction{
	private static final long serialVersionUID = 1L;
	private static Logger iLog = Logger.getLogger(YwcountlalcollectAction.class);
	
	@Autowired
	private YwcountlalcollectService service;
	
	/**
	 * 分页
	 */
	@OperateType(value = LogConstants.LOG_QUERY ,info ="listYwcountlalcollectByPage")
	public void listYwcountlalcollectByPage(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			PtyhBean ptyh = (PtyhBean)Struts2Utils.getSession().getAttribute("userInfo");
			String bmbh = ptyh.getBmbh();
			map.put("bmbh", bmbh);
			int page = Integer.parseInt(Struts2Utils.getParameter("page"));
			int rows = Integer.parseInt(Struts2Utils.getParameter("rows"));
			int start = ( (page == 0 ?  1 : page ) - 1) * rows ;
			map.put("start",start );
			map.put("limit",rows );
			Struts2Utils.renderJson(this.service.listYwcountlalcollectByPage(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwcountlalcollectAction-listYwcountlalcollectByPage-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 查询总数
	 */
	//@OperateType(value = LogConstants.LOG_QUERY ,info ="count_Ywcountlalcollect")
	public void count_Ywcountlalcollect(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.count_Ywcountlalcollect(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwcountlalcollectAction-count_Ywcountlalcollect-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 查询 Ywcountlalcollect
	 */
	@OperateType(value = LogConstants.LOG_GET ,info ="query_Ywcountlalcollect")
	public void query_Ywcountlalcollect(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.query_Ywcountlalcollect(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwcountlalcollectAction-query_Ywcountlalcollect-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 查询 一条Ywcountlalcollect
	 */
	@OperateType(value = LogConstants.LOG_GET ,info ="get_Ywcountlalcollect")
	public void get_Ywcountlalcollect(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.get_Ywcountlalcollect(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwcountlalcollectActionquery_Ywcountlalcollect-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 删除
	 */
	@OperateType(value = LogConstants.LOG_DELETE ,info ="deleteYwcountlalcollect")
	public void delete_Ywcountlalcollect(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(!CommUtils.isEmpty(map)){
				int result = service.delete_Ywcountlalcollect(map);
				Struts2Utils.renderJson(Constants.SUCCESS);
			}else{
				 throw new Exception("请正确的选择删除记录!!!");
			}
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwcountlalcollectAction-delete_Ywcountlalcollect-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}

	/**
	 * 插入
	 */
	@OperateType(value = LogConstants.LOG_ADD ,info ="insert_Ywcountlalcollect")
	public void insert_Ywcountlalcollect(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(StringUtil.checkEmpty(map.get("countId"))){
				map.put("countId",StringUtil.getUUID());
			}
			if(!StringUtil.checkEmpty(map.get("checkparam"))){
				Map sMap = new HashMap();
				sMap.put("tableparam", map.get("checkparam"));
				List ls = service.query_Ywcountlalcollect(sMap);
				if(!StringUtil.checkEmpty(ls)||ls.size()>0){
					Struts2Utils.renderJson(Constants.SAME);
				}else{
					service.insert_Ywcountlalcollect(map);
					Struts2Utils.renderJson(Constants.SUCCESS);
				}
			}else{
				service.insert_Ywcountlalcollect(map);
				Struts2Utils.renderJson(Constants.SUCCESS);
			}			
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwcountlalcollectAction-insert_Ywcountlalcollect()-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 修改
	 */
	@OperateType(value = LogConstants.LOG_UPDATE ,info ="update_Ywcountlalcollect")
	public void update_Ywcountlalcollect(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(!StringUtil.checkEmpty(map.get("checkparam"))){
				Map sMap = new HashMap();
				sMap.put("tableparam", map.get("checkparam"));
				List ls = service.query_Ywcountlalcollect(sMap);
				if(!StringUtil.checkEmpty(ls)||ls.size()>0){
					Struts2Utils.renderJson(Constants.SAME);
				}else{
					int result = service.update_Ywcountlalcollect(map);
					Struts2Utils.renderJson(Constants.SUCCESS);
				}
			}else{
				int result = service.update_Ywcountlalcollect(map);
				Struts2Utils.renderJson(Constants.SUCCESS);
			}
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwcountlalcollectAction-update_Ywcountlalcollect-error: " +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 批量删除
	 */
	@OperateType(value = LogConstants.LOG_DELETE ,info ="batch_delete_Ywcountlalcollect")
	public void batch_delete_Ywcountlalcollect(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Map m = new HashMap();
			m.put("keyword", map.get("keyword").toString());
			int result = service.batch_delete_Ywcountlalcollect(m);
			Struts2Utils.renderJson(Constants.SUCCESS);
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwcountlalcollectAction-batch_delete_Ywcountlalcollect-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 导出Excel
	 */
	@OperateType(value = LogConstants.LOG_EXPORT ,info ="exp_Ywcountlalcollect")
	public void exp_Ywcountlalcollect(){
		try {
			Map map = Struts2Utils.getRequestParameterMap();
			Map queryMap = JSONObject.fromObject(map.get("downParam"));
			queryMap.put("start",0 );
			queryMap.put("limit",5000);
			List<Map> sList = service.query_Ywcountlalcollect(queryMap);		
			List<Map> expList = new ArrayList<Map>();
			
			String username = ((PtyhBean)Struts2Utils.getSession().getAttribute("userInfo")).getYhzh();
			List<String> headerList = new ArrayList<String>();
			
			headerList.add("序号");
			headerList.add("行政区划");
			headerList.add("监控点总数");
			headerList.add("无经纬度数");
			headerList.add("经纬度缺失数");
			headerList.add("经纬度无效数");
			headerList.add("经纬度完整数");
			headerList.add("经纬度采集率");
			int monitorSum = 0;
			int nolalSum = 0;
			int invalidlalSum = 0;
			int laldefectSum = 0;
			int lalcompleteSum = 0;
			for(int i  =0;i<sList.size();i++ ){
				Map exportMap = new HashMap();
				exportMap.put("序号", i+1);
				exportMap.put("行政区划", sList.get(i).get("areaname"));
				
				monitorSum += StringUtil.str2Numeric(sList.get(i).get("monitortotal")+"");
				exportMap.put("监控点总数", sList.get(i).get("monitortotal"));
				
				nolalSum += StringUtil.str2Numeric(sList.get(i).get("nolalcount")+"");
				exportMap.put("无经纬度数", sList.get(i).get("nolalcount"));
				
				invalidlalSum += StringUtil.str2Numeric(sList.get(i).get("laldefectcount")+"");
				exportMap.put("经纬度缺失数", sList.get(i).get("laldefectcount"));
				
				laldefectSum += StringUtil.str2Numeric(sList.get(i).get("invalidlalcount")+"");
				exportMap.put("经纬度无效数", sList.get(i).get("invalidlalcount"));
				
				lalcompleteSum += StringUtil.str2Numeric(sList.get(i).get("lalcompletecount")+"");
				exportMap.put("经纬度完整数", sList.get(i).get("lalcompletecount"));
				exportMap.put("经纬度采集率", sList.get(i).get("lalcollectionrate"));
				expList.add(exportMap);
			}
			List footerList = new ArrayList();
			footerList.add( "总计");
			footerList.add("总计");
			footerList.add( monitorSum);
			footerList.add( nolalSum);
			footerList.add(invalidlalSum);
			footerList.add( laldefectSum);
			footerList.add( lalcompleteSum);
			footerList.add( new DecimalFormat(".00").format(lalcompleteSum*100.0/monitorSum)+"%");
			SimpleDateFormat formart = new SimpleDateFormat("yyyy-MM-dd");   
			String dateTime=formart.format(new Date()); 
			Map params = new HashMap();
			params.put("fileName", "统计经纬度采集率-"+dateTime);
			params.put("sheetName", "统计经纬度采集率");
			params.put("header", "统计经纬度采集率(制表时间："+DateUtil.currentDateTime()+")");	
//			new ExportEngine().exportCommData(params, cells, (ArrayList)map.get("rows"), Struts2Utils.getResponse());
			new ExportExcel().exportCommExcel(params,headerList,footerList, expList, Struts2Utils.getResponse());
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwcountlalcollectAction-exoprtPDF-error:" +e);
			
		}
	}
	
	@OperateType(value = LogConstants.LOG_EXPORT ,info ="expPDF_Ywcountlalcollect")
	public void expPDF_Ywcountlalcollect(){
		try {
			Map map = Struts2Utils.getRequestParameterMap();
			Map queryMap = JSONObject.fromObject(map.get("downParam"));
			queryMap.put("start",0 );
			queryMap.put("limit",5000);
			List<Map> sList = service.query_Ywcountlalcollect(queryMap);		
			List<Map> expList = new ArrayList<Map>();
			
			String username = ((PtyhBean)Struts2Utils.getSession().getAttribute("userInfo")).getYhzh();
			List<String> headerList = new ArrayList<String>();
			
			headerList.add("序号");
			headerList.add("行政区划");
			headerList.add("监控点总数");
			headerList.add("无经纬度数");
			headerList.add("经纬度缺失数");
			headerList.add("经纬度无效数");
			headerList.add("经纬度完整数");
			headerList.add("经纬度采集率");
			int monitorSum = 0;
			int nolalSum = 0;
			int invalidlalSum = 0;
			int laldefectSum = 0;
			int lalcompleteSum = 0;
			for(int i  =0;i<sList.size();i++ ){
				Map exportMap = new HashMap();
				exportMap.put("序号", i+1);
				exportMap.put("行政区划", sList.get(i).get("areaname"));
				
				monitorSum += StringUtil.str2Numeric(sList.get(i).get("monitortotal")+"");
				exportMap.put("监控点总数", sList.get(i).get("monitortotal"));
				
				nolalSum += StringUtil.str2Numeric(sList.get(i).get("nolalcount")+"");
				exportMap.put("无经纬度数", sList.get(i).get("nolalcount"));
				
				invalidlalSum += StringUtil.str2Numeric(sList.get(i).get("laldefectcount")+"");
				exportMap.put("经纬度缺失数", sList.get(i).get("laldefectcount"));
				
				laldefectSum += StringUtil.str2Numeric(sList.get(i).get("invalidlalcount")+"");
				exportMap.put("经纬度无效数", sList.get(i).get("invalidlalcount"));
				
				lalcompleteSum += StringUtil.str2Numeric(sList.get(i).get("lalcompletecount")+"");
				exportMap.put("经纬度完整数", sList.get(i).get("lalcompletecount"));
				exportMap.put("经纬度采集率", sList.get(i).get("lalcollectionrate"));
				expList.add(exportMap);
			}
			List footerList = new ArrayList();
			footerList.add( "总计");
			footerList.add("总计");
			footerList.add( monitorSum);
			footerList.add( nolalSum);
			footerList.add(invalidlalSum);
			footerList.add( laldefectSum);
			footerList.add( lalcompleteSum);
			footerList.add( new DecimalFormat(".00").format(lalcompleteSum*100.0/monitorSum)+"%");
			SimpleDateFormat formart = new SimpleDateFormat("yyyy-MM-dd");   
			String dateTime=formart.format(new Date()); 
			Map params = new HashMap();
			params.put("fileName", "统计经纬度采集率-"+dateTime);
			params.put("sheetName", "统计经纬度采集率");
			params.put("header", "统计经纬度采集率(制表时间："+DateUtil.currentDateTime()+")");	
//			new ExportEngine().exportCommData(params, cells, (ArrayList)map.get("rows"), Struts2Utils.getResponse());
			new ExportPDF().exportCommPDF(params,headerList,footerList, expList, Struts2Utils.getResponse());
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwcountlalcollectAction-exoprtExcel-error:" +e);
			
		}
	}
	
	/**
	 * 导入Excel
	 */
	/*
	//@OperateType(value = LogConstants.LOG_IMPORT ,info ="imp_Ywcountlalcollect")
	public String imp_Ywcountlalcollect(String excelFile,Object user) {
		String rs = "导入格式有误!";
		int rowNum = 0;
		int dataCount = 0;
		int successNum = 0;
		int repeatNum = 0;
		int failNum = 0;
		try {
		
			ExcelReader readExcel = new ExcelReader();
			readExcel.openFile(excelFile);
			readExcel.setSheetNum(0);
			int count = readExcel.getRowCount();
			iLog.info("总行数count--->" + count);
			rs = " 导入数据成功！总共"+ dataCount +"条数据,重复"+repeatNum+"条数据！失败"+failNum+"条数据!";
			File file = new File(excelFile);
			if(file.exists()){
				file.delete();
			}
		} catch (Exception e) {
			if (rowNum > 3) {
				rs = "资源部分导入(更新)失败！Excel第" + rowNum + "行起未导入(更新)成功！";
			} else {
				rs = "资源导入(更新)失败！";
			}
			iLog.error("YwcountlalcollectAction-imp_Ywcountlalcollect-error:" +e);
			e.printStackTrace();
		}		
		return rs;
	}
	*/
}
